
/*  @(#)mimepurl.c 1.2 95/07/07
 *
 *  Copyright (c) Mikael Cam.
 *                All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors inherent either
 *  to the comments or the code of this program, but if reported
 *  to me then an attempt will be made to fix them.
 */

#define _TRACE 0
#define MIMEPOUT "MIMEPOUT"
#define MIMEPBOUND "MIMEPBOUND"
#define MIMEPRULEH "MIMEPRULEH"
#include <stdio.h>
#include <stdlib.h>
#define bool int
#define EOS '\0'
#define False 0
#define True  1
#define DEFAULTB   "default"
#define NOB        "none"
#define MESSAGE "Rfrence a un document distant :"
#define ACCESSTYPE "TYPE D'ACCES :"
#define SITE       "SITE :"
#define DIRECTORY  "REPERTOIRE :"
#define NAME       "NOM DU DOCUMENT :"

  static char *specar[] = {
                     "$",                  "\\$",
		     "&",                  "\\&",
		     "%",                  "\\%",
		     "#",                  "\\#",
		     "_",                  "\\_",
		     "{",                  "\\{",
		     "}",                  "\\}",
		     "\\",                 "$\\backslash$",
		     "|",                  "$|$",
		     "<",                  "$<$",
		     ">",                  "$>$",
		     "~",                  "$\\sim$",
		     "^",                  "$\\wedge$",
		     NULL,                 NULL
		   };


char *text2latex(char *src_str)
{
  char *tgt_str;
  int  i,
       k;
  bool trouve;
  char carcour;
  int  length;
  char *boundary;
  char *RULEH;

  if(!src_str) return(NULL);
  tgt_str = (char *) malloc (sizeof(char) * 1024);
  tgt_str[0] = EOS;

  for(i = 0; i < strlen(src_str); i++)
    {
      k = 0;
      trouve = False;
      carcour = src_str[i];

		  while ((specar[k]) && (!trouve))
		    {
		      if (((char)*specar[k] == carcour) && (specar[k+1]))
			{
			  strcat(tgt_str, specar[k+1]); 
			  trouve = True;
			}
		      if(!trouve) k+=2;
		    }
      if(!trouve)
        {
	  length = strlen(tgt_str);
	  tgt_str[length] = carcour;
	  tgt_str[length + 1] = EOS;
	}
    }
  return(tgt_str);
}

int
main(int argc, char **argv)
{
  
  char *ERR[] = 
    {
      "Impossible de lire la variable MIMEPOUT...\n",
      "Erreur lors de l'ouverture du fichier cible...\n"
    };	  
  
  
  int i;
  char *mimepout;
  FILE *mimepfp;
  FILE *fp;
  char *boundary;
  char *RULEH;

  if (_TRACE) fprintf(stderr, "MIMEPURL execute!\n");
  
  if(!(mimepout = getenv(MIMEPOUT)))
    {
      fprintf(stderr, ERR[0]);
      exit(1);
    }
  
  if(!(mimepfp = fopen(mimepout, "a")))
    {
      fprintf(stderr, "%s", ERR[1]);
      exit(1);
    }

  fprintf(mimepfp, "%s\\newline\n", text2latex(MESSAGE));

if (argc > 1)
  fprintf(mimepfp, "%s %s\\newline\n", text2latex(ACCESSTYPE), text2latex(argv[1]));
if (argc > 2)
  fprintf(mimepfp, "%s %s\\newline\n", text2latex(SITE), text2latex(argv[2]));
if (argc > 3)
  fprintf(mimepfp, "%s %s\\newline\n", text2latex(DIRECTORY), text2latex(argv[3]));
if (argc > 4)
  fprintf(mimepfp, "%s %s\\newline\n", text2latex(NAME), text2latex(argv[4]));
  
  if(boundary = getenv(MIMEPBOUND))
    {
      if (strcmp(boundary, NOB))
	{
	  
	  if (!strcmp(boundary, DEFAULTB))
	    if(RULEH = getenv(MIMEPRULEH))
	      fprintf(mimepfp, "\\centerline{\\rule{\\textwidth}{%spt}}\n", RULEH);
	    else
	      if (fp = fopen(boundary, "r"))
		{
		  fclose(fp);
		  fprintf(mimepfp, "\\centerline{\\includegraphics{%s}}\n", boundary);
		}
	  
	  
	}
    }
  fflush(mimepfp);
  fclose(mimepfp);
  exit(0);
}
